// This file was generated by Rcpp::compileAttributes
// Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

#ifndef __ADMMnet_RcppExports_h__
#define __ADMMnet_RcppExports_h__

#include <RcppEigen.h>
#include <Rcpp.h>

namespace ADMMnet {

    using namespace Rcpp;

    namespace {
        void validateSignature(const char* sig) {
            Rcpp::Function require = Rcpp::Environment::base_env()["require"];
            require("ADMMnet", Rcpp::Named("quietly") = true);
            typedef int(*Ptr_validate)(const char*);
            static Ptr_validate p_validate = (Ptr_validate)
                R_GetCCallable("ADMMnet", "ADMMnet_RcppExport_validate");
            if (!p_validate(sig)) {
                throw Rcpp::function_not_exported(
                    "C++ function with signature '" + std::string(sig) + "' not found in ADMMnet");
            }
        }
    }

    inline List scaleC(Eigen::MatrixXd X) {
        typedef SEXP(*Ptr_scaleC)(SEXP);
        static Ptr_scaleC p_scaleC = NULL;
        if (p_scaleC == NULL) {
            validateSignature("List(*scaleC)(Eigen::MatrixXd)");
            p_scaleC = (Ptr_scaleC)R_GetCCallable("ADMMnet", "ADMMnet_scaleC");
        }
        RObject __result;
        {
            RNGScope __rngScope;
            __result = p_scaleC(Rcpp::wrap(X));
        }
        if (__result.inherits("interrupted-error"))
            throw Rcpp::internal::InterruptedException();
        if (__result.inherits("try-error"))
            throw Rcpp::exception(as<std::string>(__result).c_str());
        return Rcpp::as<List >(__result);
    }

    inline List OmegaC(Eigen::MatrixXd& Omega, Eigen::VectorXi& sgn) {
        typedef SEXP(*Ptr_OmegaC)(SEXP,SEXP);
        static Ptr_OmegaC p_OmegaC = NULL;
        if (p_OmegaC == NULL) {
            validateSignature("List(*OmegaC)(Eigen::MatrixXd&,Eigen::VectorXi&)");
            p_OmegaC = (Ptr_OmegaC)R_GetCCallable("ADMMnet", "ADMMnet_OmegaC");
        }
        RObject __result;
        {
            RNGScope __rngScope;
            __result = p_OmegaC(Rcpp::wrap(Omega), Rcpp::wrap(sgn));
        }
        if (__result.inherits("interrupted-error"))
            throw Rcpp::internal::InterruptedException();
        if (__result.inherits("try-error"))
            throw Rcpp::exception(as<std::string>(__result).c_str());
        return Rcpp::as<List >(__result);
    }

    inline List OmegaSC(Eigen::SparseMatrix<double>& OmegaS, Eigen::VectorXi& sgn) {
        typedef SEXP(*Ptr_OmegaSC)(SEXP,SEXP);
        static Ptr_OmegaSC p_OmegaSC = NULL;
        if (p_OmegaSC == NULL) {
            validateSignature("List(*OmegaSC)(Eigen::SparseMatrix<double>&,Eigen::VectorXi&)");
            p_OmegaSC = (Ptr_OmegaSC)R_GetCCallable("ADMMnet", "ADMMnet_OmegaSC");
        }
        RObject __result;
        {
            RNGScope __rngScope;
            __result = p_OmegaSC(Rcpp::wrap(OmegaS), Rcpp::wrap(sgn));
        }
        if (__result.inherits("interrupted-error"))
            throw Rcpp::internal::InterruptedException();
        if (__result.inherits("try-error"))
            throw Rcpp::exception(as<std::string>(__result).c_str());
        return Rcpp::as<List >(__result);
    }

    inline double maxLambdaLmC(Eigen::MatrixXd X, Eigen::VectorXd y, double alpha, Eigen::VectorXd wbeta, int N0) {
        typedef SEXP(*Ptr_maxLambdaLmC)(SEXP,SEXP,SEXP,SEXP,SEXP);
        static Ptr_maxLambdaLmC p_maxLambdaLmC = NULL;
        if (p_maxLambdaLmC == NULL) {
            validateSignature("double(*maxLambdaLmC)(Eigen::MatrixXd,Eigen::VectorXd,double,Eigen::VectorXd,int)");
            p_maxLambdaLmC = (Ptr_maxLambdaLmC)R_GetCCallable("ADMMnet", "ADMMnet_maxLambdaLmC");
        }
        RObject __result;
        {
            RNGScope __rngScope;
            __result = p_maxLambdaLmC(Rcpp::wrap(X), Rcpp::wrap(y), Rcpp::wrap(alpha), Rcpp::wrap(wbeta), Rcpp::wrap(N0));
        }
        if (__result.inherits("interrupted-error"))
            throw Rcpp::internal::InterruptedException();
        if (__result.inherits("try-error"))
            throw Rcpp::exception(as<std::string>(__result).c_str());
        return Rcpp::as<double >(__result);
    }

    inline Eigen::VectorXd cvTrimLmC(Eigen::VectorXd beta, int nn, int nn2, Eigen::VectorXi loco, Eigen::MatrixXd XF, Eigen::VectorXd yF, int NF) {
        typedef SEXP(*Ptr_cvTrimLmC)(SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP);
        static Ptr_cvTrimLmC p_cvTrimLmC = NULL;
        if (p_cvTrimLmC == NULL) {
            validateSignature("Eigen::VectorXd(*cvTrimLmC)(Eigen::VectorXd,int,int,Eigen::VectorXi,Eigen::MatrixXd,Eigen::VectorXd,int)");
            p_cvTrimLmC = (Ptr_cvTrimLmC)R_GetCCallable("ADMMnet", "ADMMnet_cvTrimLmC");
        }
        RObject __result;
        {
            RNGScope __rngScope;
            __result = p_cvTrimLmC(Rcpp::wrap(beta), Rcpp::wrap(nn), Rcpp::wrap(nn2), Rcpp::wrap(loco), Rcpp::wrap(XF), Rcpp::wrap(yF), Rcpp::wrap(NF));
        }
        if (__result.inherits("interrupted-error"))
            throw Rcpp::internal::InterruptedException();
        if (__result.inherits("try-error"))
            throw Rcpp::exception(as<std::string>(__result).c_str());
        return Rcpp::as<Eigen::VectorXd >(__result);
    }

    inline List EnetLmC(Eigen::MatrixXd X, Eigen::VectorXd y, double alpha, Eigen::VectorXd lambda, int nlambda, int ilambda, Eigen::VectorXd wbeta, int isd, int p, int N0, double thresh, int maxit) {
        typedef SEXP(*Ptr_EnetLmC)(SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP);
        static Ptr_EnetLmC p_EnetLmC = NULL;
        if (p_EnetLmC == NULL) {
            validateSignature("List(*EnetLmC)(Eigen::MatrixXd,Eigen::VectorXd,double,Eigen::VectorXd,int,int,Eigen::VectorXd,int,int,int,double,int)");
            p_EnetLmC = (Ptr_EnetLmC)R_GetCCallable("ADMMnet", "ADMMnet_EnetLmC");
        }
        RObject __result;
        {
            RNGScope __rngScope;
            __result = p_EnetLmC(Rcpp::wrap(X), Rcpp::wrap(y), Rcpp::wrap(alpha), Rcpp::wrap(lambda), Rcpp::wrap(nlambda), Rcpp::wrap(ilambda), Rcpp::wrap(wbeta), Rcpp::wrap(isd), Rcpp::wrap(p), Rcpp::wrap(N0), Rcpp::wrap(thresh), Rcpp::wrap(maxit));
        }
        if (__result.inherits("interrupted-error"))
            throw Rcpp::internal::InterruptedException();
        if (__result.inherits("try-error"))
            throw Rcpp::exception(as<std::string>(__result).c_str());
        return Rcpp::as<List >(__result);
    }

    inline List cvEnetLmC(Eigen::MatrixXd X, Eigen::VectorXd y, double alpha, Eigen::VectorXd lambda, int nlambda, Eigen::VectorXd wbeta, int N, int p, double thresh, int maxit, Eigen::MatrixXd XF, Eigen::VectorXd yF, int NF) {
        typedef SEXP(*Ptr_cvEnetLmC)(SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP);
        static Ptr_cvEnetLmC p_cvEnetLmC = NULL;
        if (p_cvEnetLmC == NULL) {
            validateSignature("List(*cvEnetLmC)(Eigen::MatrixXd,Eigen::VectorXd,double,Eigen::VectorXd,int,Eigen::VectorXd,int,int,double,int,Eigen::MatrixXd,Eigen::VectorXd,int)");
            p_cvEnetLmC = (Ptr_cvEnetLmC)R_GetCCallable("ADMMnet", "ADMMnet_cvEnetLmC");
        }
        RObject __result;
        {
            RNGScope __rngScope;
            __result = p_cvEnetLmC(Rcpp::wrap(X), Rcpp::wrap(y), Rcpp::wrap(alpha), Rcpp::wrap(lambda), Rcpp::wrap(nlambda), Rcpp::wrap(wbeta), Rcpp::wrap(N), Rcpp::wrap(p), Rcpp::wrap(thresh), Rcpp::wrap(maxit), Rcpp::wrap(XF), Rcpp::wrap(yF), Rcpp::wrap(NF));
        }
        if (__result.inherits("interrupted-error"))
            throw Rcpp::internal::InterruptedException();
        if (__result.inherits("try-error"))
            throw Rcpp::exception(as<std::string>(__result).c_str());
        return Rcpp::as<List >(__result);
    }

    inline List NetLmC(Eigen::MatrixXd& X, Eigen::VectorXd& y, double alpha, Eigen::VectorXd lambda, int nlambda, int ilambda, Eigen::VectorXd wbeta, Eigen::SparseMatrix<double>& Omega, Eigen::MatrixXd loc, Eigen::VectorXi nadj, int isd, int p, int N0, double thresh, int maxit) {
        typedef SEXP(*Ptr_NetLmC)(SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP);
        static Ptr_NetLmC p_NetLmC = NULL;
        if (p_NetLmC == NULL) {
            validateSignature("List(*NetLmC)(Eigen::MatrixXd&,Eigen::VectorXd&,double,Eigen::VectorXd,int,int,Eigen::VectorXd,Eigen::SparseMatrix<double>&,Eigen::MatrixXd,Eigen::VectorXi,int,int,int,double,int)");
            p_NetLmC = (Ptr_NetLmC)R_GetCCallable("ADMMnet", "ADMMnet_NetLmC");
        }
        RObject __result;
        {
            RNGScope __rngScope;
            __result = p_NetLmC(Rcpp::wrap(X), Rcpp::wrap(y), Rcpp::wrap(alpha), Rcpp::wrap(lambda), Rcpp::wrap(nlambda), Rcpp::wrap(ilambda), Rcpp::wrap(wbeta), Rcpp::wrap(Omega), Rcpp::wrap(loc), Rcpp::wrap(nadj), Rcpp::wrap(isd), Rcpp::wrap(p), Rcpp::wrap(N0), Rcpp::wrap(thresh), Rcpp::wrap(maxit));
        }
        if (__result.inherits("interrupted-error"))
            throw Rcpp::internal::InterruptedException();
        if (__result.inherits("try-error"))
            throw Rcpp::exception(as<std::string>(__result).c_str());
        return Rcpp::as<List >(__result);
    }

    inline List cvNetLmC(Eigen::MatrixXd& X, Eigen::VectorXd& y, double alpha, Eigen::VectorXd lambda, int nlambda, Eigen::VectorXd wbeta, Eigen::SparseMatrix<double>& Omega, Eigen::MatrixXd loc, Eigen::VectorXi nadj, int N, int p, double thresh, int maxit, Eigen::MatrixXd XF, Eigen::VectorXd yF, int NF) {
        typedef SEXP(*Ptr_cvNetLmC)(SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP);
        static Ptr_cvNetLmC p_cvNetLmC = NULL;
        if (p_cvNetLmC == NULL) {
            validateSignature("List(*cvNetLmC)(Eigen::MatrixXd&,Eigen::VectorXd&,double,Eigen::VectorXd,int,Eigen::VectorXd,Eigen::SparseMatrix<double>&,Eigen::MatrixXd,Eigen::VectorXi,int,int,double,int,Eigen::MatrixXd,Eigen::VectorXd,int)");
            p_cvNetLmC = (Ptr_cvNetLmC)R_GetCCallable("ADMMnet", "ADMMnet_cvNetLmC");
        }
        RObject __result;
        {
            RNGScope __rngScope;
            __result = p_cvNetLmC(Rcpp::wrap(X), Rcpp::wrap(y), Rcpp::wrap(alpha), Rcpp::wrap(lambda), Rcpp::wrap(nlambda), Rcpp::wrap(wbeta), Rcpp::wrap(Omega), Rcpp::wrap(loc), Rcpp::wrap(nadj), Rcpp::wrap(N), Rcpp::wrap(p), Rcpp::wrap(thresh), Rcpp::wrap(maxit), Rcpp::wrap(XF), Rcpp::wrap(yF), Rcpp::wrap(NF));
        }
        if (__result.inherits("interrupted-error"))
            throw Rcpp::internal::InterruptedException();
        if (__result.inherits("try-error"))
            throw Rcpp::exception(as<std::string>(__result).c_str());
        return Rcpp::as<List >(__result);
    }

    inline double maxLambdaCoxC(Eigen::MatrixXd X, Eigen::VectorXd tevent, int N, Eigen::VectorXi nevent, Eigen::VectorXi nevent1, Eigen::VectorXi loc1, int n, double alpha, Eigen::VectorXd wbeta, int N0) {
        typedef SEXP(*Ptr_maxLambdaCoxC)(SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP);
        static Ptr_maxLambdaCoxC p_maxLambdaCoxC = NULL;
        if (p_maxLambdaCoxC == NULL) {
            validateSignature("double(*maxLambdaCoxC)(Eigen::MatrixXd,Eigen::VectorXd,int,Eigen::VectorXi,Eigen::VectorXi,Eigen::VectorXi,int,double,Eigen::VectorXd,int)");
            p_maxLambdaCoxC = (Ptr_maxLambdaCoxC)R_GetCCallable("ADMMnet", "ADMMnet_maxLambdaCoxC");
        }
        RObject __result;
        {
            RNGScope __rngScope;
            __result = p_maxLambdaCoxC(Rcpp::wrap(X), Rcpp::wrap(tevent), Rcpp::wrap(N), Rcpp::wrap(nevent), Rcpp::wrap(nevent1), Rcpp::wrap(loc1), Rcpp::wrap(n), Rcpp::wrap(alpha), Rcpp::wrap(wbeta), Rcpp::wrap(N0));
        }
        if (__result.inherits("interrupted-error"))
            throw Rcpp::internal::InterruptedException();
        if (__result.inherits("try-error"))
            throw Rcpp::exception(as<std::string>(__result).c_str());
        return Rcpp::as<double >(__result);
    }

    inline double pletaCm(Eigen::VectorXd& xb, Eigen::VectorXd& exb, Eigen::VectorXi& nevent, Eigen::VectorXi& nevent1, Eigen::VectorXi& loc1, int& n, int& ifast, int& itwo) {
        typedef SEXP(*Ptr_pletaCm)(SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP);
        static Ptr_pletaCm p_pletaCm = NULL;
        if (p_pletaCm == NULL) {
            validateSignature("double(*pletaCm)(Eigen::VectorXd&,Eigen::VectorXd&,Eigen::VectorXi&,Eigen::VectorXi&,Eigen::VectorXi&,int&,int&,int&)");
            p_pletaCm = (Ptr_pletaCm)R_GetCCallable("ADMMnet", "ADMMnet_pletaCm");
        }
        RObject __result;
        {
            RNGScope __rngScope;
            __result = p_pletaCm(Rcpp::wrap(xb), Rcpp::wrap(exb), Rcpp::wrap(nevent), Rcpp::wrap(nevent1), Rcpp::wrap(loc1), Rcpp::wrap(n), Rcpp::wrap(ifast), Rcpp::wrap(itwo));
        }
        if (__result.inherits("interrupted-error"))
            throw Rcpp::internal::InterruptedException();
        if (__result.inherits("try-error"))
            throw Rcpp::exception(as<std::string>(__result).c_str());
        return Rcpp::as<double >(__result);
    }

    inline Eigen::VectorXd cvTrimCoxC(Eigen::VectorXd beta, int nn, int nn2, Eigen::VectorXi loco, Eigen::MatrixXd XF, int NF, Eigen::VectorXi neventF, Eigen::VectorXi nevent1F, Eigen::VectorXi loc1F, int nF, Eigen::MatrixXd X, int N, Eigen::VectorXi nevent, Eigen::VectorXi nevent1, Eigen::VectorXi loc1, int n, int ifast, int itwo) {
        typedef SEXP(*Ptr_cvTrimCoxC)(SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP);
        static Ptr_cvTrimCoxC p_cvTrimCoxC = NULL;
        if (p_cvTrimCoxC == NULL) {
            validateSignature("Eigen::VectorXd(*cvTrimCoxC)(Eigen::VectorXd,int,int,Eigen::VectorXi,Eigen::MatrixXd,int,Eigen::VectorXi,Eigen::VectorXi,Eigen::VectorXi,int,Eigen::MatrixXd,int,Eigen::VectorXi,Eigen::VectorXi,Eigen::VectorXi,int,int,int)");
            p_cvTrimCoxC = (Ptr_cvTrimCoxC)R_GetCCallable("ADMMnet", "ADMMnet_cvTrimCoxC");
        }
        RObject __result;
        {
            RNGScope __rngScope;
            __result = p_cvTrimCoxC(Rcpp::wrap(beta), Rcpp::wrap(nn), Rcpp::wrap(nn2), Rcpp::wrap(loco), Rcpp::wrap(XF), Rcpp::wrap(NF), Rcpp::wrap(neventF), Rcpp::wrap(nevent1F), Rcpp::wrap(loc1F), Rcpp::wrap(nF), Rcpp::wrap(X), Rcpp::wrap(N), Rcpp::wrap(nevent), Rcpp::wrap(nevent1), Rcpp::wrap(loc1), Rcpp::wrap(n), Rcpp::wrap(ifast), Rcpp::wrap(itwo));
        }
        if (__result.inherits("interrupted-error"))
            throw Rcpp::internal::InterruptedException();
        if (__result.inherits("try-error"))
            throw Rcpp::exception(as<std::string>(__result).c_str());
        return Rcpp::as<Eigen::VectorXd >(__result);
    }

    inline List EnetCoxC(Eigen::MatrixXd X, Eigen::VectorXd tevent, double alpha, Eigen::VectorXd lambda, int nlambda, Eigen::VectorXd wbeta, int N, Eigen::VectorXi nevent, Eigen::VectorXi nevent1, Eigen::VectorXi loc1, int n, int p, int N0, double thresh, int maxit, int ifast) {
        typedef SEXP(*Ptr_EnetCoxC)(SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP);
        static Ptr_EnetCoxC p_EnetCoxC = NULL;
        if (p_EnetCoxC == NULL) {
            validateSignature("List(*EnetCoxC)(Eigen::MatrixXd,Eigen::VectorXd,double,Eigen::VectorXd,int,Eigen::VectorXd,int,Eigen::VectorXi,Eigen::VectorXi,Eigen::VectorXi,int,int,int,double,int,int)");
            p_EnetCoxC = (Ptr_EnetCoxC)R_GetCCallable("ADMMnet", "ADMMnet_EnetCoxC");
        }
        RObject __result;
        {
            RNGScope __rngScope;
            __result = p_EnetCoxC(Rcpp::wrap(X), Rcpp::wrap(tevent), Rcpp::wrap(alpha), Rcpp::wrap(lambda), Rcpp::wrap(nlambda), Rcpp::wrap(wbeta), Rcpp::wrap(N), Rcpp::wrap(nevent), Rcpp::wrap(nevent1), Rcpp::wrap(loc1), Rcpp::wrap(n), Rcpp::wrap(p), Rcpp::wrap(N0), Rcpp::wrap(thresh), Rcpp::wrap(maxit), Rcpp::wrap(ifast));
        }
        if (__result.inherits("interrupted-error"))
            throw Rcpp::internal::InterruptedException();
        if (__result.inherits("try-error"))
            throw Rcpp::exception(as<std::string>(__result).c_str());
        return Rcpp::as<List >(__result);
    }

    inline List cvEnetCoxC(Eigen::MatrixXd X, Eigen::VectorXd tevent, double alpha, Eigen::VectorXd lambda, int nlambda, Eigen::VectorXd wbeta, int N, Eigen::VectorXi nevent, Eigen::VectorXi nevent1, Eigen::VectorXi loc1, int n, int p, int N0, double thresh, int maxit, int ifast, Eigen::MatrixXd XF, int NF, Eigen::VectorXi neventF, Eigen::VectorXi nevent1F, Eigen::VectorXi loc1F, int nF) {
        typedef SEXP(*Ptr_cvEnetCoxC)(SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP);
        static Ptr_cvEnetCoxC p_cvEnetCoxC = NULL;
        if (p_cvEnetCoxC == NULL) {
            validateSignature("List(*cvEnetCoxC)(Eigen::MatrixXd,Eigen::VectorXd,double,Eigen::VectorXd,int,Eigen::VectorXd,int,Eigen::VectorXi,Eigen::VectorXi,Eigen::VectorXi,int,int,int,double,int,int,Eigen::MatrixXd,int,Eigen::VectorXi,Eigen::VectorXi,Eigen::VectorXi,int)");
            p_cvEnetCoxC = (Ptr_cvEnetCoxC)R_GetCCallable("ADMMnet", "ADMMnet_cvEnetCoxC");
        }
        RObject __result;
        {
            RNGScope __rngScope;
            __result = p_cvEnetCoxC(Rcpp::wrap(X), Rcpp::wrap(tevent), Rcpp::wrap(alpha), Rcpp::wrap(lambda), Rcpp::wrap(nlambda), Rcpp::wrap(wbeta), Rcpp::wrap(N), Rcpp::wrap(nevent), Rcpp::wrap(nevent1), Rcpp::wrap(loc1), Rcpp::wrap(n), Rcpp::wrap(p), Rcpp::wrap(N0), Rcpp::wrap(thresh), Rcpp::wrap(maxit), Rcpp::wrap(ifast), Rcpp::wrap(XF), Rcpp::wrap(NF), Rcpp::wrap(neventF), Rcpp::wrap(nevent1F), Rcpp::wrap(loc1F), Rcpp::wrap(nF));
        }
        if (__result.inherits("interrupted-error"))
            throw Rcpp::internal::InterruptedException();
        if (__result.inherits("try-error"))
            throw Rcpp::exception(as<std::string>(__result).c_str());
        return Rcpp::as<List >(__result);
    }

    inline List NetCoxC(Eigen::MatrixXd& X, Eigen::VectorXd tevent, double alpha, Eigen::VectorXd lambda, int nlambda, Eigen::VectorXd wbeta, Eigen::SparseMatrix<double>& Omega, Eigen::MatrixXd loc, Eigen::VectorXi nadj, int N, Eigen::VectorXi nevent, Eigen::VectorXi nevent1, Eigen::VectorXi loc1, int n, int p, int N0, double thresh, int maxit, int ifast) {
        typedef SEXP(*Ptr_NetCoxC)(SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP);
        static Ptr_NetCoxC p_NetCoxC = NULL;
        if (p_NetCoxC == NULL) {
            validateSignature("List(*NetCoxC)(Eigen::MatrixXd&,Eigen::VectorXd,double,Eigen::VectorXd,int,Eigen::VectorXd,Eigen::SparseMatrix<double>&,Eigen::MatrixXd,Eigen::VectorXi,int,Eigen::VectorXi,Eigen::VectorXi,Eigen::VectorXi,int,int,int,double,int,int)");
            p_NetCoxC = (Ptr_NetCoxC)R_GetCCallable("ADMMnet", "ADMMnet_NetCoxC");
        }
        RObject __result;
        {
            RNGScope __rngScope;
            __result = p_NetCoxC(Rcpp::wrap(X), Rcpp::wrap(tevent), Rcpp::wrap(alpha), Rcpp::wrap(lambda), Rcpp::wrap(nlambda), Rcpp::wrap(wbeta), Rcpp::wrap(Omega), Rcpp::wrap(loc), Rcpp::wrap(nadj), Rcpp::wrap(N), Rcpp::wrap(nevent), Rcpp::wrap(nevent1), Rcpp::wrap(loc1), Rcpp::wrap(n), Rcpp::wrap(p), Rcpp::wrap(N0), Rcpp::wrap(thresh), Rcpp::wrap(maxit), Rcpp::wrap(ifast));
        }
        if (__result.inherits("interrupted-error"))
            throw Rcpp::internal::InterruptedException();
        if (__result.inherits("try-error"))
            throw Rcpp::exception(as<std::string>(__result).c_str());
        return Rcpp::as<List >(__result);
    }

    inline List cvNetCoxC(Eigen::MatrixXd& X, Eigen::VectorXd tevent, double alpha, Eigen::VectorXd lambda, int nlambda, Eigen::VectorXd wbeta, Eigen::SparseMatrix<double>& Omega, Eigen::MatrixXd loc, Eigen::VectorXi nadj, int N, Eigen::VectorXi nevent, Eigen::VectorXi nevent1, Eigen::VectorXi loc1, int n, int p, int N0, double thresh, int maxit, int ifast, Eigen::MatrixXd XF, int NF, Eigen::VectorXi neventF, Eigen::VectorXi nevent1F, Eigen::VectorXi loc1F, int nF) {
        typedef SEXP(*Ptr_cvNetCoxC)(SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP,SEXP);
        static Ptr_cvNetCoxC p_cvNetCoxC = NULL;
        if (p_cvNetCoxC == NULL) {
            validateSignature("List(*cvNetCoxC)(Eigen::MatrixXd&,Eigen::VectorXd,double,Eigen::VectorXd,int,Eigen::VectorXd,Eigen::SparseMatrix<double>&,Eigen::MatrixXd,Eigen::VectorXi,int,Eigen::VectorXi,Eigen::VectorXi,Eigen::VectorXi,int,int,int,double,int,int,Eigen::MatrixXd,int,Eigen::VectorXi,Eigen::VectorXi,Eigen::VectorXi,int)");
            p_cvNetCoxC = (Ptr_cvNetCoxC)R_GetCCallable("ADMMnet", "ADMMnet_cvNetCoxC");
        }
        RObject __result;
        {
            RNGScope __rngScope;
            __result = p_cvNetCoxC(Rcpp::wrap(X), Rcpp::wrap(tevent), Rcpp::wrap(alpha), Rcpp::wrap(lambda), Rcpp::wrap(nlambda), Rcpp::wrap(wbeta), Rcpp::wrap(Omega), Rcpp::wrap(loc), Rcpp::wrap(nadj), Rcpp::wrap(N), Rcpp::wrap(nevent), Rcpp::wrap(nevent1), Rcpp::wrap(loc1), Rcpp::wrap(n), Rcpp::wrap(p), Rcpp::wrap(N0), Rcpp::wrap(thresh), Rcpp::wrap(maxit), Rcpp::wrap(ifast), Rcpp::wrap(XF), Rcpp::wrap(NF), Rcpp::wrap(neventF), Rcpp::wrap(nevent1F), Rcpp::wrap(loc1F), Rcpp::wrap(nF));
        }
        if (__result.inherits("interrupted-error"))
            throw Rcpp::internal::InterruptedException();
        if (__result.inherits("try-error"))
            throw Rcpp::exception(as<std::string>(__result).c_str());
        return Rcpp::as<List >(__result);
    }

}

#endif // __ADMMnet_RcppExports_h__
